Hooks:PreHook(RaycastWeaponBase, "_fire_raycast", "FRcustomammousageinit", function(self)
	if self._ammo_data and self._ammo_data.bullet_class and self._ammo_data.bullet_class_alt then
		if self._ammo_data.bullet_class_alt.fd == "wpn_fps_customsetbullet" then
			self._bullet_class = CoreSerialize.string_to_classtable(self._ammo_data.bullet_class_alt.class[(#self._ammo_data.bullet_class_alt.class-(self:get_ammo_remaining_in_clip()%#self._ammo_data.bullet_class_alt.class))])
			self._bullet_slotmask = self._bullet_class:bullet_slotmask()
			self._blank_slotmask = self._bullet_class:blank_slotmask()
		end
	end
end)

Hooks:PostHook(RaycastWeaponBase, "_update_stats_values", "USVcustomammousageinit", function(self)
	if self._ammo_data and self._ammo_data.bullet_class then
		local alt_ammo_data = managers.weapon_factory:get_ammo_data_from_weapon(self._factory_id, self._blueprint) or {}
		if alt_ammo_data and alt_ammo_data.bullet_class and alt_ammo_data.bullet_class_alt then
			self._ammo_data.bullet_class_alt = alt_ammo_data.bullet_class_alt
		end
	end
end)




local bullet_class_alt_FlameBullet_give_fire_damage = FlameBulletBase.give_fire_damage

function FlameBulletBase:give_fire_damage(col_ray, weapon_unit, user_unit, damage, armor_piercing)
	if weapon_unit.base and weapon_unit:base()._ammo_data and weapon_unit:base()._ammo_data.bullet_class and weapon_unit:base()._ammo_data.bullet_class_alt then
		if weapon_unit:base()._ammo_data.bullet_class_alt.fd == "wpn_fps_customsetbullet" then
			local action_data = {
				variant = "fire",
				damage = damage,
				weapon_unit = weapon_unit,
				attacker_unit = user_unit,
				col_ray = col_ray,
				armor_piercing = armor_piercing,
				fire_dot_data = {
					dot_trigger_chance = "100",
					dot_damage = "10",
					dot_length = "3.1",
					dot_trigger_max_distance = "3000",
					dot_tick_period = "0.5"
				}
			}
			return col_ray.unit:character_damage():damage_fire(action_data)
		end
	end
	return bullet_class_alt_FlameBullet_give_fire_damage(self, col_ray, weapon_unit, user_unit, damage, armor_piercing)
end

local bullet_class_alt_InstantExplosiveBuck_give_fire_damage = InstantExplosiveBuckBase.give_fire_damage

function InstantExplosiveBuckBase:give_fire_damage(col_ray, weapon_unit, user_unit, damage, armor_piercing)
	if weapon_unit.base and weapon_unit:base()._ammo_data and weapon_unit:base()._ammo_data.bullet_class and weapon_unit:base()._ammo_data.bullet_class_alt then
		if weapon_unit:base()._ammo_data.bullet_class_alt.fd == "wpn_fps_customsetbullet" then
			local action_data = {
				variant = "fire",
				damage = damage,
				weapon_unit = weapon_unit,
				attacker_unit = user_unit,
				col_ray = col_ray,
				armor_piercing = armor_piercing,
				fire_dot_data = {
					dot_trigger_chance = "100",
					dot_damage = "50",
					dot_length = "4",
					dot_trigger_max_distance = "100000",
					dot_tick_period = "0.5"
				}
			}
			return col_ray.unit:character_damage():damage_fire(action_data)
		end
	end
	return bullet_class_alt_InstantExplosiveBuck_give_fire_damage(self, col_ray, weapon_unit, user_unit, damage, armor_piercing)
end